<p align="center">
  <img src="https://avatars3.githubusercontent.com/u/23202313" alt="Compodoc: The missing documentation tool for your Angular application" width="226">
  <br/>
  <a href="https://travis-ci.org/compodoc/compodoc"><img src="https://img.shields.io/travis/compodoc/compodoc/develop.svg?label=Linux%20build" alt="Linux Build Status"/></a>
  <a href="https://ci.appveyor.com/project/vogloblinsky/compodoc/branch/develop"><img src="https://img.shields.io/appveyor/ci/vogloblinsky/compodoc/develop.svg?label=Windows%20build" alt="Windows Build Status"/></a>
  <a href="https://codecov.io/gh/compodoc/compodoc"><img src="https://codecov.io/gh/compodoc/compodoc/branch/develop/graph/badge.svg" alt="Codecov"/></a>
  <a href="https://www.npmjs.com/package/@compodoc/compodoc"><img src="https://badge.fury.io/js/%40compodoc%2Fcompodoc.svg" alt="npm badge"/></a>
  <a href="https://sonarcloud.io/dashboard?id=compodoc_compodoc"><img src="https://sonarcloud.io/api/project_badges/measure?project=compodoc_compodoc&metric=alert_status" alt="Quality Gate Status"/></a>
  <br/>
  <a href="https://david-dm.org/compodoc/compodoc"><img src="https://david-dm.org/compodoc/compodoc.svg" alt="npm dependencies"/></a>
  <a href="https://david-dm.org/compodoc/compodoc?type=dev"><img src="https://david-dm.org/compodoc/compodoc/dev-status.svg" alt="npm devDependencies"/></a>
  <br/>
  <a href="https://npmcharts.com/compare/@compodoc/compodoc?minimal=true"><img src="https://img.shields.io/npm/dm/@compodoc/compodoc.svg?style=flat" alt="NPM Downloads"/></a>
  <a href="https://opensource.org/licenses/MIT"><img src="http://img.shields.io/badge/license-MIT-brightgreen.svg" alt="MIT badge"/></a>
  <br/>
  <a href="#backers" alt="sponsors on Open Collective"><img src="https://opencollective.com/compodoc/backers/badge.svg" /></a> <a href="#sponsors" alt="Sponsors on Open Collective"><img src="https://opencollective.com/compodoc/sponsors/badge.svg" /></a>
</p>
<p align="center">
    <img src="https://saucelabs.com/browser-matrix/compodoc.svg" alt="saucelabs badge"/>
</p>
<p align="center">
    <a href="https://gitter.im/compodoc/compodoc" target="_blank"><img src="https://badges.gitter.im/Join%20Chat.svg" alt="Gitter badge"/></a><br><br>
</p>

<p align="center">The missing documentation tool for your Angular application.<br><br></p>

<p align="center">
  <img src="https://raw.githubusercontent.com/compodoc/compodoc/master/screenshots/main-view.gif" alt="Compodoc: The missing documentation tool for your Angular application"/>
</p>

# Live Demo

A live demo is available — **[see it in action][demo]** !

The demo features documentation generated for a simple [TodoMVC application].

[demo]: https://compodoc.github.io/compodoc-demo-todomvc-angular/
[todomvc application]: https://github.com/compodoc/compodoc-demo-todomvc-angular

# Features

-   **Clean, simple design** — Navigate the documentation on the left side, read it on the right.

-   **Beautiful themes** — Seven themes are available from well known documentation tools like [Gitbook], [Read the Docs] and projects like [Vagrant], [Laravel], [Postmark] and [Stripe].

-   **Search** — Includes a powerful search engine ([lunr.js]) for easily finding what you're looking for.

-   **Automatic table of contents** — API table of contents is generated using elements found during files parsing.

-   **JSDoc light support** — Support for `@param`, `@returns`, `@link`, `@ignore` and `@example` tags.

-   **Documentation coverage** — Get the documentation coverage report of your project.

-   **Angular CLI-friendly** — Supports [Angular CLI] projects out-of-the-box.

-   **Offline** — No server needed, no sources uploaded online, documentation generated entirely offline.

-   **Open-source and on npm** — Use it directly in your project using [npm] and a single script—that's it!

[gitbook]: https://www.gitbook.com
[read the docs]: https://readthedocs.org/
[vagrant]: https://www.vagrantup.com/docs/
[laravel]: https://laravel.com/docs/5.3
[postmark]: https://developer.postmarkapp.com/
[stripe]: https://stripe.com/docs/api
[lunr.js]: https://lunrjs.com/
[angular cli]: https://cli.angular.io/
[npm]: https://www.npmjs.com/

# Documentation

Official documentation has moved to [https://compodoc.github.io/website/](https://compodoc.github.io/website/guides/getting-started.html).

# Installation

Ready to get started? [Read installation instructions](https://compodoc.github.io/website/guides/installation.html).

# 🏅 Backers

Thank you to all our backers ! Support us with a monthly donation and help us continue our activities. [Become a backer][support-url]

[![Backers][backers-image]][support-url]

# 🎖 Sponsors

Support this project by becoming a sponsor. Your logo will show up here with a link to your website. [Become a sponsor][support-url]

[![Sponsors][sponsors-image]][support-url]

# Contributing

Want to file a bug, contribute some code, or improve documentation? Excellent!

Read up on our guidelines for [contributing](https://github.com/compodoc/compodoc/blob/master/CONTRIBUTING.md).

# Contributors

This project exists thanks to all these people.

| [<img alt="vogloblinsky" src="https://avatars3.githubusercontent.com/u/2841805?v=4&s=117" width="117"/>](https://github.com/vogloblinsky) | [<img alt="manekinekko" src="https://avatars3.githubusercontent.com/u/1699357?v=4&s=117" width="117"/>](https://github.com/manekinekko) | [<img alt="mattlewis92" src="https://avatars1.githubusercontent.com/u/6425649?v=4&s=117" width="117"/>](https://github.com/mattlewis92) | [<img alt="JonasMH" src="https://avatars0.githubusercontent.com/u/1939229?v=4&s=117" width="117"/>](https://github.com/JonasMH) | [<img alt="rprotsyk" src="https://avatars0.githubusercontent.com/u/104502?v=4&s=117" width="117"/>](https://github.com/rprotsyk) | [<img alt="daniele-zurico" src="https://avatars0.githubusercontent.com/u/3193095?v=4&s=117" width="117"/>](https://github.com/daniele-zurico) | [<img alt="profimedica" src="https://avatars0.githubusercontent.com/u/2903499?v=4&s=117" width="117"/>](https://github.com/profimedica) | [<img alt="guilhermevrs" src="https://avatars0.githubusercontent.com/u/1570567?v=4&s=117" width="117"/>](https://github.com/guilhermevrs) |
| :---------------------------------------------------------------------------------------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------------------------------------: | :-----------------------------------------------------------------------------------------------------------------------------: | :------------------------------------------------------------------------------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------------------------------------: | :---------------------------------------------------------------------------------------------------------------------------------------: |
|                                              [vogloblinsky](https://github.com/vogloblinsky)                                              |                                              [manekinekko](https://github.com/manekinekko)                                              |                                              [mattlewis92](https://github.com/mattlewis92)                                              |                                              [JonasMH](https://github.com/JonasMH)                                              |                                             [rprotsyk](https://github.com/rprotsyk)                                              |                                              [daniele-zurico](https://github.com/daniele-zurico)                                              |                                              [profimedica](https://github.com/profimedica)                                              |                                              [guilhermevrs](https://github.com/guilhermevrs)                                              |

| [<img alt="vogloblinsky" src="https://avatars3.githubusercontent.com/u/32763448?v=4&s=117" width="117"/>](https://github.com/dp-1a) | [<img alt="guilhermevrs" src="https://avatars0.githubusercontent.com/u/14924373?v=4&s=117" width="117"/>](https://github.com/ValentinGot) | [<img alt="Blakesalot" src="https://avatars1.githubusercontent.com/u/10159693?s=460&v=4" width="117"/>](https://github.com/Blakesalot) | [<img alt="Brigitte Hofmeister" src="https://avatars1.githubusercontent.com/u/16089658?s=460&v=4" width="117"/>](https://github.com/bhofmei) | [<img alt="lichangfeng" src="https://avatars2.githubusercontent.com/u/8101989?s=460&v=4" width="117"/>](https://github.com/lichangfeng) |
| :---------------------------------------------------------------------------------------------------------------------------------: | :---------------------------------------------------------------------------------------------------------------------------------------: | :------------------------------------------------------------------------------------------------------------------------------------: | :------------------------------------------------------------------------------------------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------------------------------------: |
|                                                  [dp-1a](https://github.com/dp-1a)                                                  |                                               [ValentinGot](https://github.com/ValentinGot)                                               |                                             [Blake Simmon](https://github.com/Blakesalot)                                              |                                              [Brigitte Hofmeister](https://github.com/bhofmei)                                               |                                              [lichangfeng](https://github.com/lichangfeng)                                              |

# Big Thanks

Cross-browser Testing Platform and Open Source <3 Provided by [Sauce Labs][homepage]

[homepage]: https://saucelabs.com

# License

Everything in this repository is [licensed under the MIT License][license] unless otherwise specified.

Copyright (c) 2016 – 2019 [Vincent Ogloblinsky]

[license]: https://github.com/compodoc/compodoc/blob/master/LICENSE
[vincent ogloblinsky]: https://www.vincentogloblinsky.com
[support-url]: https://opencollective.com/compodoc#support
[backers-image]: https://opencollective.com/compodoc/backers.svg
[sponsors-image]: https://opencollective.com/compodoc/sponsors.svg
